#!/usr/bin/perl

sub computer {
# czyta podstawowe dane o zestawie
	$kernel{arch}=""; 
	$kernel{kernel}="";
	$box{vendor}="";
	$box{product}="";
	$box{type}="";
	$box{bios_date}="";
	$box{bios_version}="";
	$box{bios_vendor}="";

	print "Informacje o komputerze";
	my @comp=`/usr/bin/lshal -l -u computer`;
	for(@comp){
		$kernel{arch}=$1 if /system.kernel.machine = '(.*)'/ ; 
		$kernel{kernel}=$1 if /system.kernel.version = '(.*)'/ ;
		$box{vendor}=$1 if /system.vendor = '(.*)'/ ;
		$box{product}=$1 if /[^\.]system.product = '(.*)'/ ;
		$box{type}=$1 if /smbios.chassis.type = '(.*)'/ ;
		$box{bios_date}=$1 if /smbios.bios.release_date = '(.*)'/ ;
		$box{bios_version}=$1 if /smbios.bios.version = '(.*)'/ ;
		$box{bios_vendor}=$1 if /smbios.bios.vendor = '(.*)'/ ;
		print ".";
	}
	print "[OK]\n"
}

sub normal2 {
	my $st=shift;
	my $l=2-length($st);
	$st=("0"x$l).$st;
	return $st;
}

sub normal4 {
	my $st=shift;
	my $l=4-length($st);
	$st=("0"x$l).$st;
	return $st;
}

sub pci {
# czyta dane o jednym urzadzeniu PCI
	my %dev=();
	$dev{vendor_id}="";
	$dev{product_id}="";
	$dev{pci_id}="";
	$dev{pci_class}="";
	$dev{subvendor_id}="";
	$dev{subproduct_id}="";
	$dev{kmodule}="";
	$dev{module}="";
	$dev{device}="";

	my $com="/usr/bin/lshal -l -u $_";
	my @dane=qx/$com/;
	my $sysfs="";
	for (@dane) {
		$dev{vendor_id}=$1 if /pci.vendor_id.*\(0x([abcdef0-9]*)\)/;
		$dev{vendor_id}=normal4($dev{vendor_id});
		$dev{product_id}=$1 if /pci.product_id.*\(0x([abcdef0-9]*)\)/;
		$dev{product_id}=normal4($dev{product_id});
		$dev{pci_id}=$1 if /pci.device.class.*\(0x([abcdef0-9]*)\)/;
		$dev{pci_id}=normal2($dev{pci_id});
		$dev{pci_class}=$1 if /pci.device.subclass.*\(0x([abcdef0-9]*)\)/;
		$dev{pci_class}=normal2($dev{pci_class});
		$dev{subvendor_id}=$1 if /pci.subsys_vendor_id.*\(0x([abcdef0-9]*)\)/;
		$dev{subvendor_id}=normal4($dev{subvendor_id});
		$dev{subproduct_id}=$1 if /pci.subsys_product_id.*\(0x([abcdef0-9]*)\)/;
		$dev{subproduct_id}=normal4($dev{subproduct_id});
		$sysfs=$1 if /pci.linux.sysfs_path = '(.*)'/;
		$dev{kmodule}=$1 if /info.linux.driver = '(.*)'/;
		$dev{kmodule} =~ s/ /\*/g;
	}
	$com="[ -e $sysfs/driver/module ] && ls -l $sysfs/driver/module | sed -e 's#.*/##'";
	$dev{module}=qx/$com/;
	chop($dev{module});
	$dev{device}=$1 if $sysfs =~ /.*\/(.*)$/;
	return %dev;
}

sub pci_list {
# czta dane o urzadzeniach PCI
	my $com="/usr/bin/lshal -s | grep \"pci_[[:digit:]]\\\{1,4\\\}_[[:digit:]]\\\{1,4\\\}\\\$\"";
	my @lista=qx/$com/;
	print "Urzadzenia PCI";
	for(@lista){
		push @devs, { pci($_) } ;
		print ".";
	}
	print "[OK]\n";
}

sub procesor {
# zbiera informacje o procesorze
	print "Informacje o procesorze";
	open(FILE,"< /proc/cpuinfo");
	while (<FILE>) {
		$proc{vendor_id}=$1 if /^vendor_id.*: (.*)$/;
		$proc{model}=$1 if /^model name.*: (.*)$/;
		print ".";
	}
	close FILE;
	if ($proc{vendor_id} eq "AuthenticAMD") {
		$proc{vendor_id}="AMD";
	} elsif ( $proc{vendor_id} eq "GenuineIntel") { 
		$proc{vendor_id}="Intel";
	} else {
		$proc{vendor_id}="Other";
	}
	print "[OK]\n";
}

sub memory {
# informacje o pamieci
	print "Informacje o pamieci";
	open(FILE,"< /proc/meminfo");
	while(<FILE>) {
		$mem{memory}=$1 if /^MemTotal:\W*([0-9]*) kB/;
		print ".";
	}
	close FILE;
	$mem{memory}=int ( $mem{memory} / 1024 );
	print "[OK]\n";
}

sub storage {
# info o pojedynczym urzadzeniu
	my %dev=();
	$dev{type}="";
	$dev{bus}="";
	$dev{vendor}="";
	$dev{model}="";
	$dev{device}="";
	$dev{size}="";
	$dev{write}="";
	$dev{read}="";
	$dev{cdtype}="";
	
	my $sysfs="";

	my $com="/usr/bin/lshal -l -u $_";
	my @dane=qx/$com/;
	for (@dane) {
		$dev{type}=$1 if /storage.drive_type = '(.*)'/;
		$dev{bus}=$1 if /storage.bus = '(.*)'/;
		$dev{vendor}=$1 if /storage.vendor = '(.*)'/;
		$dev{vendor} =~ s/ /\*/g;
		$dev{vendor}="unknown" if $dev{vendor} eq "";
		$dev{model}=$1 if /storage.model = '(.*)'/;
		$dev{model} =~ s/ /\*/g;
		$dev{device}=$1 if /block.device = '(.*)'/;
		$sysfs=$1 if /linux.sysfs_path = '(.*)'/;
	}
	if ($dev{type} eq "disk") {
		$com="cat $sysfs/size";
		my $size=qx/$com/;
		$size=$size*512;           # na kB
		$size=int $size/(1000*1000*1000); # na GB
		$dev{size}=$size;
	}
	if ($dev{type} eq "cdrom") {
		for (@dane) {
			$dev{write}=$1 if /storage.cdrom.write_speed = ([0-9]*)/;
			$dev{read}=$1 if /storage.cdrom.read_speed = ([0-9]*)/;
			$dev{cdtype}=$1 if /storage.cdrom.([^._]*) = true/ && $dev{cdtype} eq "";
		}
	}
	return %dev;
}

sub storages {
# informacje o dyskach, CD itp.
	my $com="/usr/bin/lshal -s | grep \"storage_serial\"";
	my @lista=qx/$com/;
	print "Dyski, CD itp.";
	for(@lista){
		push @storage, { storage($_) } ;
		print ".";
	}
	print "[OK]\n";

}

sub make_ini {
# towrzy wynikowy plik
	print "Plik wynikowy ".$LOGFILE;
	open(FILE,"> ".$LOGFILE) || die "Nie moge otworzyc pliku";
	print FILE "[box]\n";
	foreach $klucz (keys %box) {    
		print FILE $klucz." = \"".$box{$klucz}."\"\n";
		print ".";
	}
	print FILE "[distro]\n";
	print FILE "distro = \"".$DISTRO."\"\n";
	print ".";
	
	print FILE "[CPU]\n";
	foreach $klucz (keys %proc) {    
		print FILE $klucz." = \"".$proc{$klucz}."\"\n";
		print ".";
	}
	print FILE "[kernel]\n";
	foreach $klucz (keys %kernel) {    
		print FILE $klucz." = \"".$kernel{$klucz}."\"\n";
		print ".";
	}
	print FILE "[memory]\n";
	foreach $klucz (keys %mem) {    
		print FILE $klucz." = \"".$mem{$klucz}."\"\n";
		print ".";
	}
	print FILE "[PCI]\n";
	$ile=@devs;
	for (my $i=0;$i<$ile;$i++) {
		$linia=$devs[$i]{device}." = \"";
		$dev=$devs[$i];
		if ( $$dev{module} eq "" && $$dev{kmodule} ne "") {
			$$dev{module}="<inside>";
		}
		if ( $$dev{module} eq "" && $$dev{kmodule} eq "") {
			$$dev{module}="<nomod>";
			$$dev{kmodule}="<nomod>";
		}
		$linia=$linia.$$dev{module}." ".$$dev{kmodule};
		$linia=$linia." ".$$dev{pci_id}." ".$$dev{pci_class};
		$linia=$linia." ".$$dev{vendor_id}." ".$$dev{product_id};
		$linia=$linia." ".$$dev{subvendor_id}." ".$$dev{subproduct_id};

		print FILE $linia."\"\n";
		print ".";
	}
	print FILE "[disk]\n";
	$ile=@storage;
	for(my $i=0;$i<$ile;$i++) {
		$linia=$storage[$i]{device}." = \"";
		$dev=$storage[$i];
		$linia .= $$dev{type}." ";
		$linia .= $$dev{bus}." ";
		$linia .= $$dev{vendor}." ";
		$linia .= $$dev{model}." ";
		if ($$dev{type} eq "disk") {
			$linia .= $$dev{size};
		}
		if ($$dev{type} eq "cdrom") {
			$linia .= $$dev{cdtype}." ";
			$linia .= $$dev{read}." ";
			$linia .= $$dev{write};		
		}

		print FILE $linia."\"\n";
		print ".";
	}

	close FILE;
	print "[OK]\n";
}

################## Main #########################
if ($#ARGV+1!=1)
{
	print "[ERROR] invalid number of parameters\n";
	exit 1;
}
$LOGFILE=$ARGV[0];

$DISTRO=`cat /etc/aurox-release | awk '{print \$1\" \"\$4}'`;
chop($DISTRO);

computer();
procesor();
memory();
pci_list();
storages();

make_ini();